<template>
  <div
    class="sm:max-w-xl lg:max-w-4xl xl:max-w-6xl 2xl:max-w-full mx-4 sm:mx-auto 2xl:mx-8"
  >
    <div class="pt-10 lg:pt-20 mb-8 sm:flex justify-between">
      <img
        class="mx-auto sm:mx-0 mb-8 sm:mb-0 sm:"
        src="/logo.png"
        alt="Song Quiz logo"
      />
      <div class="text-white sm:flex sm:items-end">
        <p class="font-bold uppercase text-center mb-2 sm:mb-0 sm:leading-none">
          {{ playerName }}
        </p>
        <p class="text-center sm:leading-none sm:ml-8">
          Your Score: <span class="font-bold">{{ currentScore }}</span>
        </p>
      </div>
    </div>
    <div class="bg-quiz-200 rounded-b-xl rounded-t-sm overflow-hidden">
      <div class="h-1 rounded-sm" :class="`bg-progress-step-${gameStep}`"></div>
      <ul
        class="progress-bar flex justify-evenly items-center border-b rounded-sm border-color-100"
      >
        <template v-for="block in quizData">
          <li
            :key="block.id"
            :class="`text-progress-${block.id} text-progress-step-${gameStep}`"
            class="uppercase font-bold text-sm py-2 text-quiz-100"
          >
            {{ block.genre }}
          </li>
          <!-- eslint-disable-next-line vue/require-v-for-key -->
          <li>
            <svg
              class="text-quiz-100"
              :class="`text-progress-${block.id} text-progress-step-${gameStep}`"
              xmlns="http://www.w3.org/2000/svg"
              width="21"
              height="19"
              viewBox="0 0 21 17"
              fill="none"
            >
              <path
                fill-rule="evenodd"
                clip-rule="evenodd"
                d="M12.877 0.994414C12.6543 0.831114 12.3414 0.879252 12.1781 1.10193C12.0148 1.32462 12.0629 1.63752 12.2856 1.80082L18.0118 6.00004H1.44873C1.17259 6.00004 0.94873 6.2239 0.94873 6.50004C0.94873 6.77619 1.17259 7.00004 1.44873 7.00004H18.0118L12.2856 11.1993C12.0629 11.3626 12.0148 11.6755 12.1781 11.8981C12.3414 12.1208 12.6543 12.169 12.877 12.0057L19.8296 6.90704C19.8329 6.90471 19.8361 6.90234 19.8393 6.89993L20.3846 6.50004L19.8389 6.09984C19.836 6.09765 19.8331 6.09549 19.8301 6.09336L12.877 0.994414Z"
              />
            </svg>
          </li>
        </template>
      </ul>
      <div class="grid xl:grid-cols-12 gap-2 xl:gap-12 px-2 py-8 xl:p-16">
        <div class="xl:col-span-5 mb-4 xl:mb-0">
          <p
            class="text-white font-bold font-prompt text-2xl xl:text-3xl mb-2.5"
          >
            <span class="capitalize font-prompt">{{ currentGenre }}</span> song
          </p>
          <p class="text-quiz-100 mb-4 xl:mb-8">
            Listen to the audio and guess what song is it from the list
          </p>
          <div class="bg-quiz-300 rounded">
            <AudioPlayer
              ref="audioPlayer"
              class="mb-5"
              :audio-src="currentCorrectAnswerAudioSrc"
              :is-cover="true"
              :cover-image="currentCorrectAnswerCoverImage"
            />
          </div>
          <template v-for="(song, index) in currentSongs">
            <div
              :key="song.id"
              class="flex items-center border rounded border-color-100 p-4 mb-2.5 cursor-pointer"
              :class="{
                'bg-correct':
                  checkedOptions[index] && checkedOptions[index] !== undefined,
                'bg-wrong':
                  !checkedOptions[index] && checkedOptions[index] !== undefined,
              }"
              @click="onAnswerClick(index)"
            >
              <div>
                <div
                  class="w-6 sm:w-8 h-6 sm:h-8 border border-color-100 rounded-full mr-4 flex justify-center items-center"
                >
                  <svg
                    v-if="
                      checkedOptions[index] &&
                      checkedOptions[index] !== undefined
                    "
                    xmlns="http://www.w3.org/2000/svg"
                    width="13"
                    height="11"
                    viewBox="0 0 13 11"
                    fill="none"
                  >
                    <path
                      d="M1 5.86957L4.09375 9L12 1"
                      stroke="white"
                      stroke-width="2"
                      stroke-linecap="round"
                    />
                  </svg>
                  <svg
                    v-if="
                      !checkedOptions[index] &&
                      checkedOptions[index] !== undefined
                    "
                    xmlns="http://www.w3.org/2000/svg"
                    width="10.4"
                    height="10.35"
                    viewBox="0 0 10.4 10.35"
                    fill="none"
                  >
                    <path
                      fill-rule="evenodd"
                      clip-rule="evenodd"
                      d="M10.1056 8.6392C10.4973 9.02851 10.4993 9.66167 10.11 10.0534C9.72069 10.4451 9.08752 10.4471 8.69578 10.0578L5.20036 6.5841L1.7049 10.0578C1.31316 10.4472 0.68 10.4452 0.290694 10.0534C-0.0986119 9.66171 -0.0966395 9.02854 0.295099 8.63924L3.78172 5.17427L0.295099 1.70931C-0.0966395 1.32 -0.0986119 0.686839 0.290694 0.295099C0.68 -0.0966396 1.31316 -0.0986118 1.7049 0.290694L5.20036 3.76444L8.69578 0.290732C9.08752 -0.0985743 9.72069 -0.0966019 10.11 0.295137C10.4993 0.686876 10.4973 1.32004 10.1056 1.70934L6.619 5.17427L10.1056 8.6392Z"
                      fill="white"
                    ></path>
                  </svg>
                </div>
              </div>
              <p class="text-quiz-100">
                0{{ index + 1 }}: {{ song.name }} - {{ song.songTitle }}
              </p>
            </div>
          </template>
        </div>
        <div class="xl:col-span-7 relative">
          <img
            v-if="isNaN(currentSelect)"
            src="@/static/images/union.png"
            alt="union"
            class="hidden xl:block w-full absolute top-80 2xl:top-32 -right-28"
          />
          <div v-if="!isNaN(currentSelect)">
            <h2 class="text-white text-xl font-bold font-prompt mb-4 xl:mb-8">
              0{{ currentSelect + 1 }}: {{ currentSelectData.name }} -
              {{ currentSelectData.songTitle }}
            </h2>
            <div class="rounded-t-lg overflow-hidden xl:h-96">
              <img
                :src="
                  'https://levi9-song-quiz.herokuapp.com/api/' +
                  currentSelectData.image
                "
                :alt="currentSelectData.name"
                class="xl:object-cover"
              />
            </div>
            <div class="bg-quiz-300 rounded-b">
              <AudioPlayer
                ref="audioPlayer"
                class="mb-4 xl:mb-8"
                :audio-src="
                  'https://levi9-song-quiz.herokuapp.com/api/' +
                  currentSelectData.audio
                "
                :is-cover="false"
              />
            </div>
            <p class="text-quiz-100 text-center mb-4 xl:mb-8">
              {{ currentSelectData.description }}
            </p>
          </div>
        </div>
      </div>
    </div>
    <div class="flex justify-end my-4">
      <UiButton
        :class="{ 'btn-default': isNextBlock, 'btn-disabled': !isNextBlock }"
        :disabled="!isNextBlock"
        :btn-name="!isFinal ? 'Next question' : 'See my score'"
        btn-type="button"
        @clickBtn="nextBlock"
      />
    </div>
  </div>
</template>

<script>
import UiButton from '@/components/UI/Button/UiButton'
import AudioPlayer from '@/components/AudioPlayer/AudioPlayer'

export default {
  components: {
    UiButton,
    AudioPlayer,
  },
	middleware: 'isGame',
  data() {
    return {
      playerName: this.$store.state.playerName,
      quizData: this.$store.state.quizData,
      correctAnswers: this.$store.state.correctAnswers,
      currentGameBlock: 0,
      gameStep: 1,
      isCorrect: false,
      isNextBlock: false,
      stepScore: 3,
      isFinal: false,
      currentSelect: NaN,
      checkedOptions: [],
    }
  },
  computed: {
    currentScore() {
      // eslint-disable-next-line dot-notation
      return this.$store.getters.currentScore
    },
    currentGenre() {
      // eslint-disable-next-line dot-notation
      return this.quizData[this.currentGameBlock]['genre']
    },
    currentSongs() {
      // eslint-disable-next-line dot-notation
      return this.quizData[this.currentGameBlock]['data']
    },
    currentCorrectAnswer() {
      return this.correctAnswers[this.currentGameBlock]
    },
    currentCorrectAnswerCoverImage() {
      let currentCorrectAnswerCoverImage
      if (this.isCorrect) {
        currentCorrectAnswerCoverImage = `https://levi9-song-quiz.herokuapp.com/api/${
          // eslint-disable-next-line dot-notation
          this.currentSongs[this.currentCorrectAnswer]['image']
        }`
      } else {
        currentCorrectAnswerCoverImage = require('../../static/images/unknown-song.png')
      }
      return currentCorrectAnswerCoverImage
    },
    currentCorrectAnswerAudioSrc() {
      return `https://levi9-song-quiz.herokuapp.com/api/${
        // eslint-disable-next-line dot-notation
        this.currentSongs[this.currentCorrectAnswer]['audio']
      }`
    },
    currentSelectData() {
      return !isNaN(this.currentSelect)
        ? this.currentSongs[this.currentSelect]
        : null
    },
  },
  methods: {
    onAnswerClick(index) {
      this.currentSelect = index
      if (!this.isCorrect) {
        if (this.correctAnswers[this.currentGameBlock] === index) {
          this.$store.dispatch('updateScore', this.stepScore)
          this.isCorrect = true
          if (this.gameStep === 7) {
            this.isFinal = true
          }
          this.unlockNextBlock()
        } else {
          this.stepScore = this.stepScore - 1
        }
        this.checkedOptions[index] = this.isCorrect
      }
    },
    unlockNextBlock() {
      this.isNextBlock = true
      this.gameStep = this.gameStep + 1
    },
    nextBlock() {
      if (this.gameStep < 8) {
        this.isNextBlock = false
        this.isCorrect = false
        this.gameStep = this.gameStep + 1
        this.currentGameBlock = this.currentGameBlock + 1
        this.stepScore = 3
        this.currentSelect = NaN
        this.checkedOptions = []
      } else {
        this.$router.push('/summary')
      }
    },
  },
}
</script>
